// MT Engine MK2
// Copyleft 2014 the Mojon Twins

// extern.h
// External custom code to be run from a script

// =======[CUSTOM MODIFICATION]=======
unsigned char *textbuff = 23458;
unsigned char *extaddress;
unsigned char exti, extx, exty, stepbystep, keyp;
unsigned char is_cutscene = 0;
extern unsigned char textos_load [0];

extern const unsigned char final1 [0], final2 [0], final3 [0], final4 [0], penter1 [0];
const unsigned char *cutscene_images [] = { final1, final2, final3, final4 };

#asm
	._final1
		BINARY "final1.bin"
	._final2
		BINARY "final2.bin"
	._final3
		BINARY "final3.bin"
	._final4
		BINARY "final4.bin"
	._penter1
		BINARY "penter1.bin"
#endasm

//

void cuts_clr (void) {
	cortina ();
	#asm
		ld hl, 16384
		ld de, 16385
		ld bc, 6143
		ld (hl), 0
		ldir
		ld hl, 22528
		ld de, 22529
		ld bc, 767
		ld (hl), 71
		ldir
	#endasm
}

void cutsc_img (const unsigned char *ptr) {
	cuts_clr ();
	unpack ((unsigned int) (ptr), 16384);
}

void do_extern_action (unsigned char n) {
	// Add custom code here.
	// Leovigildo: like Ninjajar plus some extra stuff, but for 48K
	// Leovigildo F: trimmed down / modified version. [ENDING SEQUENCE]

	if (n < 200) {
		// Show text n
		stepbystep = 1;
		
		asm_int [0] = (n - 1) << 1;
		#asm
			; First we get where to look for the packed string
			
			ld a, (_asm_int)
			ld e, a
			ld a, (_asm_int + 1)
			ld d, a
			
			ld hl, _textos_load
			add hl, de
			ld c, (hl)
			inc hl
			ld b, (hl)
			push bc
			pop de
			ld hl, _textos_load
			add hl, de
			
			ld de, 23458
	
			; 5-bit scaped depacker by na_th_an
			; Contains code by Antonio Villena
			
			ld a, $80
	
		.fbsd_mainb
	        call fbsd_unpackc
	        ld c, a
	        ld a, b
	        and a
	        jr z, fbsd_fin
	        call fbsd_stor
	        ld a, c
	        jr fbsd_mainb	
	
		.fbsd_stor
	        cp 31
	        jr z, fbsd_escaped
	        add a, 64
	        jr fbsd_stor2
		.fbsd_escaped
	        ld a, c
	        call fbsd_unpackc
	        ld c, a
	        ld a, b
	        add a, 32
		.fbsd_stor2
	        ld (de), a
	        inc de
	        ret
	
		.fbsd_unpackc
	        ld      b, 0x08
		.fbsd_bucle
	        call    fbsd_getbit
	        rl      b
	        jr      nc, fbsd_bucle
	        ret
	
		.fbsd_getbit
	        add     a, a
	        ret     nz
	        ld      a, (hl)
	        inc     hl
	        rla
	        ret        
	        
		.fbsd_fin
			ld (de), a	
			;
			;		
			
		#endasm	
		saca_a_todo_el_mundo_de_aqui (0);
		if (is_cutscene == 0) {
			exty = 9;
			extx = 11; 
		} else {
			exty = 13;
			extx = 4; 
		}
		
		espera_activa (10);
		
		// Draw text
		
		extaddress = textbuff + 1;
		keyp = 1;
		while (exti = *extaddress ++) {
			if (exti == '%') {
				if (is_cutscene) {extx = 4; exty += 2;} else {extx = 11; exty ++;}
			} else {
				sp_PrintAtInv (exty, extx, 71, exti - 32);
				extx ++;
			}
			if (stepbystep) {
	#ifdef MODE_128K
	#asm
				halt
	#endasm
				if (exti != 32 && is_cutscene == 0) wyz_play_sound (8);
	#asm
				halt
				halt
	#endasm
	#endif
				peta_el_beeper (6);
				sp_UpdateNow ();
			}
			
			if (button_pressed ()) {
				if (keyp == 0) {
					stepbystep = 0;
				} 
			} else {
				keyp = 0;
			}
		}
		sp_UpdateNow ();
		sp_WaitForNoKey ();
		while (button_pressed ());
		espera_activa (5000);
		
		if (is_cutscene) {
			for (exti = 11; exti < 24; exti ++) {
				print_str (3, exti, 71, "                          ");
				sp_UpdateNow ();
			}
		}
	} else {
		cutsc_img (cutscene_images [n - 200]);
	}
}

#asm
	._textos_load
		BINARY "texts.bin"
#endasm
