// MT Engine MK2
// Copyleft 2014 the Mojon Twins

// oldenems.h
// Enemy initialization (when entering a new screen), MT Engine MK2 style

#ifdef COUNT_SCR_ENEMS_ON_FLAG
	flags [COUNT_SCR_ENEMS_ON_FLAG]	= 0;
#endif

	for (gpit = 0; gpit < 3; gpit ++) {
		en_an_frame [gpit] = 0;
		en_an_count [gpit] = 3;
		en_an_state [gpit] = 0;
		enoffsmasi = enoffs + gpit;
#ifdef ENABLE_RANDOM_RESPAWN
		en_an_fanty_activo [gpit] = 0;
#endif
#ifdef RESPAWN_ON_ENTER
		// Back to life!
#ifdef RESPAWN_ON_REENTER
		{
#else
		if (do_respawn) {
#endif
			malotes [enoffsmasi].t &= 0xEF;	
			en_an_state [gpit] = 0;
#if defined(PLAYER_CAN_FIRE) || defined(PLAYER_CAN_PUNCH) || defined(PLAYER_CAN_SWORD)
#ifdef MODE_128K
			malotes [enoffsmasi].life = level_data.enems_life;
#else
			malotes [enoffsmasi].life = ENEMIES_LIFE_GAUGE;
#endif
#endif
		}
#endif

#ifdef COUNT_SCR_ENEMS_ON_FLAG
#if defined(DISABLE_PLATFORMS) || defined(PLAYER_MOGGY_STYLE)
		if (malotes [enoffs + gpit].t) flags [COUNT_SCR_ENEMS_ON_FLAG] ++;
#else
		if (malotes [enoffs + gpit].t && 4 != malotes [enoffs + gpit].t) flags [COUNT_SCR_ENEMS_ON_FLAG] ++;
#endif		
#endif

		// Prepare enemies
		gpt = malotes [enoffs + gpit].t;
#ifndef DISABLE_PLATFORMS
		if (gpt == 4) {
			en_an_base_frame [gpit] = 6;
		} else 
#endif		
		if (gpt) {
			// sprite
			en_an_base_frame [gpit] = (gpt & 3) << 1;
			
			// behaviour specific
			gpjt = ((gpt >> 2) & 3);
			switch (gpjt) {
				case 2:
					// Fanty
					en_an_base_frame [gpit] = TYPE_6_FIXED_SPRITE << 1;
					en_an_x [gpit] = malotes [enoffsmasi].x << 6;
					en_an_y [gpit] = malotes [enoffsmasi].y << 6;
					en_an_vx [gpit] = en_an_vy [gpit] = 0;
					en_an_state [gpit] = TYPE_6_IDLE;
					break;
				case 3:
					// Pursuer
					en_an_alive [gpit] = 0;
					en_an_dead_row [gpit] = 0;
					break;
			}
		} else {
			en_an_next_frame [gpit] = sprite_18_a;
		}
	 }
	 