@echo off
echo ### MAKING MAP ###
..\utils\map2bin.exe ..\map\mapa.map 3 6 99 map.bin bolts.bin
echo ### MAKING ENEMS ###
..\utils\ene2bin.exe 3 6 1 ..\enems\enems.ene enems.bin hotspots.bin
echo ### MAKING TILESET ###
..\utils\ts2bin.exe ..\gfx\font.png ..\gfx\work.png ts.bin
echo ### MAKING SPRITESET ###
..\utils\sprcnv.exe ..\gfx\sprites.png sprites.h
rem ..\utils\spg2bin.exe ..\gfx\drop.png spdrop.bin
rem ..\utils\spg2bin.exe ..\gfx\arrow.png sparrow.bin
echo ### MAKING FIXED ###
..\utils\png2scr.exe ..\gfx\title.png ..\gfx\title.scr
..\utils\apack.exe ..\gfx\title.scr title.bin
..\utils\png2scr.exe ..\gfx\ending.png ..\gfx\ending.scr 1
..\utils\apack.exe ..\gfx\ending.scr ending.bin
echo ### MAKING SPECIAL FIXED ###
..\utils\png2scr.exe ..\gfx\final1.png ..\gfx\final1.scr 2
..\utils\apack.exe ..\gfx\final1.scr final1.bin
..\utils\png2scr.exe ..\gfx\final2.png ..\gfx\final2.scr 2
..\utils\apack.exe ..\gfx\final2.scr final2.bin
..\utils\png2scr.exe ..\gfx\final3.png ..\gfx\final3.scr 2
..\utils\apack.exe ..\gfx\final3.scr final3.bin
..\utils\png2scr.exe ..\gfx\final4.png ..\gfx\final4.scr 3
..\utils\apack.exe ..\gfx\final4.scr final4.bin
..\utils\png2scr.exe ..\gfx\penter1.png ..\gfx\penter1.scr 1
..\utils\apack.exe ..\gfx\penter1.scr penter1.bin
del ..\gfx\*.scr
echo ### MAKING LOADING
..\utils\png2scr.exe ..\gfx\loading.png loading.bin
rem echo ### MAKING SCRIPT ###
rem ..\utils\msc3.exe ..\script\leof.spt 18
echo ### MAKING TEXTS ###
..\utils\textstuffer.exe ..\texts\texts.txt texts.bin 24
echo ### COMPILING ###
zcc +zx -vn leof.c -o leof.bin -lsplib2 -zorg=24200
echo ### MAKING TAPS ###
..\utils\bas2tap -a10 -sFINAL loader.bas loader.tap
..\utils\bin2tap -o loading.tap -a 16384 loading.bin
..\utils\bin2tap -o main.tap -a 24200 leof.bin
copy /b loader.tap + loading.tap + main.tap leof.tap
echo ### LIMPIANDO ###
del loader.tap
del main.tap
del loading.tap
del leof.bin
echo ### DONE ###
